/* game.c generated by valac 0.40.0, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <math.h>


#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;
enum  {
	TILE_0_PROPERTY,
	TILE_CLOSED_PROPERTY,
	TILE_NUM_PROPERTIES
};
static GParamSpec* tile_properties[TILE_NUM_PROPERTIES];
enum  {
	TILE_MOVE_SIGNAL,
	TILE_CLOSE_SIGNAL,
	TILE_NUM_SIGNALS
};
static guint tile_signals[TILE_NUM_SIGNALS] = {0};

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_SCORE_PROPERTY,
	GAME_COLOR_NUM_PROPERTY,
	GAME_ROWS_PROPERTY,
	GAME_COLUMNS_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
enum  {
	GAME_UPDATE_SCORE_SIGNAL,
	GAME_COMPLETE_SIGNAL,
	GAME_STARTED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint grid_x;
	gint grid_y;
	gint color;
	gboolean visited;
};

struct _TileClass {
	GObjectClass parent_class;
};

struct _TilePrivate {
	gboolean _closed;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	Tile** tiles;
	gint tiles_length1;
	gint tiles_length2;
	gboolean is_started;
	gint _score;
	gint _color_num;
	gint _rows;
	gint _columns;
};


static gpointer tile_parent_class = NULL;
static gpointer game_parent_class = NULL;

GType tile_get_type (void) G_GNUC_CONST;
#define TILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TILE, TilePrivate))
Tile* tile_new (gint x,
                gint y,
                gint c);
Tile* tile_construct (GType object_type,
                      gint x,
                      gint y,
                      gint c);
void tile_update_position (Tile* self,
                           gint new_x,
                           gint new_y);
gboolean tile_get_closed (Tile* self);
void tile_set_closed (Tile* self,
                      gboolean value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void tile_finalize (GObject * obj);
static void _vala_tile_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_tile_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
#define GAME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GAME, GamePrivate))
Game* game_new (gint rows,
                gint columns,
                gint color_num);
Game* game_construct (GType object_type,
                      gint rows,
                      gint columns,
                      gint color_num);
static GList* _game_connected_tiles (Game* self,
                              Tile* li);
gint game_get_rows (Game* self);
gint game_get_columns (Game* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
GList* game_connected_tiles (Game* self,
                             Tile* li);
Tile* game_get_tile (Game* self,
                     gint x,
                     gint y);
gboolean game_remove_connected_tiles (Game* self,
                                      Tile* tile);
void game_increment_score_from_tiles (Game* self,
                                      gint n_tiles);
gboolean game_has_completed (Game* self);
gboolean game_has_won (Game* self);
void game_increment_score (Game* self,
                           gint increment);
void game_reset_visit (Game* self);
gint game_get_score (Game* self);
void game_set_score (Game* self,
                     gint value);
gint game_get_color_num (Game* self);
void game_set_color_num (Game* self,
                         gint value);
void game_set_rows (Game* self,
                    gint value);
void game_set_columns (Game* self,
                       gint value);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


Tile*
tile_construct (GType object_type,
                gint x,
                gint y,
                gint c)
{
	Tile * self = NULL;
	self = (Tile*) g_object_new (object_type, NULL);
	self->grid_x = x;
	self->grid_y = y;
	self->color = c;
	return self;
}


Tile*
tile_new (gint x,
          gint y,
          gint c)
{
	return tile_construct (TYPE_TILE, x, y, c);
}


void
tile_update_position (Tile* self,
                      gint new_x,
                      gint new_y)
{
	gint old_x = 0;
	gint _tmp0_;
	gint old_y = 0;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->grid_x;
	old_x = _tmp0_;
	_tmp1_ = self->grid_y;
	old_y = _tmp1_;
	_tmp3_ = old_x;
	if (new_x != _tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp4_;
		_tmp4_ = old_y;
		_tmp2_ = new_y != _tmp4_;
	}
	if (_tmp2_) {
		gboolean _tmp5_;
		gboolean _tmp6_;
		self->grid_x = new_x;
		self->grid_y = new_y;
		_tmp5_ = tile_get_closed (self);
		_tmp6_ = _tmp5_;
		if (!_tmp6_) {
			gint _tmp7_;
			gint _tmp8_;
			_tmp7_ = old_x;
			_tmp8_ = old_y;
			g_signal_emit (self, tile_signals[TILE_MOVE_SIGNAL], 0, _tmp7_, _tmp8_, new_x, new_y);
		}
	}
}


gboolean
tile_get_closed (Tile* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_closed;
	result = _tmp0_;
	return result;
}


void
tile_set_closed (Tile* self,
                 gboolean value)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_closed = value;
	_tmp0_ = self->priv->_closed;
	if (_tmp0_) {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = self->grid_x;
		_tmp2_ = self->grid_y;
		g_signal_emit (self, tile_signals[TILE_CLOSE_SIGNAL], 0, _tmp1_, _tmp2_);
	}
	g_object_notify_by_pspec ((GObject *) self, tile_properties[TILE_CLOSED_PROPERTY]);
}


static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
}


static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static void
tile_class_init (TileClass * klass)
{
	tile_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TilePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_tile_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tile_set_property;
	G_OBJECT_CLASS (klass)->finalize = tile_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TILE_CLOSED_PROPERTY, tile_properties[TILE_CLOSED_PROPERTY] = g_param_spec_boolean ("closed", "closed", "closed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	tile_signals[TILE_MOVE_SIGNAL] = g_signal_new ("move", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
	tile_signals[TILE_CLOSE_SIGNAL] = g_signal_new ("close", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
}


static void
tile_instance_init (Tile * self)
{
	self->priv = TILE_GET_PRIVATE (self);
	self->priv->_closed = FALSE;
	self->visited = FALSE;
}


static void
tile_finalize (GObject * obj)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TILE, Tile);
	G_OBJECT_CLASS (tile_parent_class)->finalize (obj);
}


/**
 *  This is the model layer of a tile.
 */
GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tile), 0, (GInstanceInitFunc) tile_instance_init, NULL };
		GType tile_type_id;
		tile_type_id = g_type_register_static (G_TYPE_OBJECT, "Tile", &g_define_type_info, 0);
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}


static void
_vala_tile_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
	switch (property_id) {
		case TILE_CLOSED_PROPERTY:
		g_value_set_boolean (value, tile_get_closed (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_tile_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
	switch (property_id) {
		case TILE_CLOSED_PROPERTY:
		tile_set_closed (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


Game*
game_construct (GType object_type,
                gint rows,
                gint columns,
                gint color_num)
{
	Game * self = NULL;
	Tile** _tmp0_;
	self = (Game*) g_object_new (object_type, NULL);
	self->priv->_rows = rows;
	self->priv->_columns = columns;
	self->priv->_color_num = color_num;
	_tmp0_ = g_new0 (Tile*, (rows * columns) + 1);
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->tiles = _tmp0_;
	self->priv->tiles_length1 = rows;
	self->priv->tiles_length2 = columns;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = x;
				if (!(_tmp3_ < columns)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							gint _tmp6_;
							gint c = 0;
							Tile** _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
							gint _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							gint _tmp12_;
							Tile* _tmp13_;
							Tile* _tmp14_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = y;
							if (!(_tmp6_ < rows)) {
								break;
							}
							c = (gint) floor (g_random_double () * color_num);
							_tmp7_ = self->priv->tiles;
							_tmp7__length1 = self->priv->tiles_length1;
							_tmp7__length2 = self->priv->tiles_length2;
							_tmp8_ = y;
							_tmp9_ = x;
							_tmp10_ = x;
							_tmp11_ = y;
							_tmp12_ = c;
							_tmp13_ = tile_new (_tmp10_, _tmp11_, _tmp12_);
							_g_object_unref0 (_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_]);
							_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_] = _tmp13_;
							_tmp14_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
						}
					}
				}
			}
		}
	}
	self->priv->is_started = FALSE;
	return self;
}


Game*
game_new (gint rows,
          gint columns,
          gint color_num)
{
	return game_construct (TYPE_GAME, rows, columns, color_num);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


static GList*
_game_connected_tiles (Game* self,
                       Tile* li)
{
	GList* result = NULL;
	GList* cl = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gint x = 0;
	gint _tmp4_;
	gint y = 0;
	gint _tmp5_;
	Tile* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gint _tmp28_;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gint _tmp46_;
	gint _tmp47_;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
	gint _tmp65_;
	g_return_val_if_fail (self != NULL, NULL);
	cl = NULL;
	_tmp1_ = li->visited;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = tile_get_closed (li);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	}
	if (_tmp0_) {
		result = cl;
		return result;
	}
	_tmp4_ = li->grid_x;
	x = _tmp4_;
	_tmp5_ = li->grid_y;
	y = _tmp5_;
	li->visited = TRUE;
	_tmp6_ = _g_object_ref0 (li);
	cl = g_list_append (cl, _tmp6_);
	_tmp9_ = y;
	_tmp10_ = self->priv->_rows;
	if ((_tmp9_ + 1) < _tmp10_) {
		Tile** _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		gint _tmp12_;
		gint _tmp13_;
		Tile* _tmp14_;
		_tmp11_ = self->priv->tiles;
		_tmp11__length1 = self->priv->tiles_length1;
		_tmp11__length2 = self->priv->tiles_length2;
		_tmp12_ = y;
		_tmp13_ = x;
		_tmp14_ = _tmp11_[((_tmp12_ + 1) * _tmp11__length2) + _tmp13_];
		_tmp8_ = _tmp14_ != NULL;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		gint _tmp15_;
		Tile** _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		gint _tmp17_;
		gint _tmp18_;
		Tile* _tmp19_;
		gint _tmp20_;
		_tmp15_ = li->color;
		_tmp16_ = self->priv->tiles;
		_tmp16__length1 = self->priv->tiles_length1;
		_tmp16__length2 = self->priv->tiles_length2;
		_tmp17_ = y;
		_tmp18_ = x;
		_tmp19_ = _tmp16_[((_tmp17_ + 1) * _tmp16__length2) + _tmp18_];
		_tmp20_ = _tmp19_->color;
		_tmp7_ = _tmp15_ == _tmp20_;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		Tile** _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		gint _tmp22_;
		gint _tmp23_;
		Tile* _tmp24_;
		GList* _tmp25_;
		_tmp21_ = self->priv->tiles;
		_tmp21__length1 = self->priv->tiles_length1;
		_tmp21__length2 = self->priv->tiles_length2;
		_tmp22_ = y;
		_tmp23_ = x;
		_tmp24_ = _tmp21_[((_tmp22_ + 1) * _tmp21__length2) + _tmp23_];
		_tmp25_ = _game_connected_tiles (self, _tmp24_);
		cl = g_list_concat (cl, _tmp25_);
	}
	_tmp28_ = y;
	if ((_tmp28_ - 1) >= 0) {
		Tile** _tmp29_;
		gint _tmp29__length1;
		gint _tmp29__length2;
		gint _tmp30_;
		gint _tmp31_;
		Tile* _tmp32_;
		_tmp29_ = self->priv->tiles;
		_tmp29__length1 = self->priv->tiles_length1;
		_tmp29__length2 = self->priv->tiles_length2;
		_tmp30_ = y;
		_tmp31_ = x;
		_tmp32_ = _tmp29_[((_tmp30_ - 1) * _tmp29__length2) + _tmp31_];
		_tmp27_ = _tmp32_ != NULL;
	} else {
		_tmp27_ = FALSE;
	}
	if (_tmp27_) {
		gint _tmp33_;
		Tile** _tmp34_;
		gint _tmp34__length1;
		gint _tmp34__length2;
		gint _tmp35_;
		gint _tmp36_;
		Tile* _tmp37_;
		gint _tmp38_;
		_tmp33_ = li->color;
		_tmp34_ = self->priv->tiles;
		_tmp34__length1 = self->priv->tiles_length1;
		_tmp34__length2 = self->priv->tiles_length2;
		_tmp35_ = y;
		_tmp36_ = x;
		_tmp37_ = _tmp34_[((_tmp35_ - 1) * _tmp34__length2) + _tmp36_];
		_tmp38_ = _tmp37_->color;
		_tmp26_ = _tmp33_ == _tmp38_;
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		Tile** _tmp39_;
		gint _tmp39__length1;
		gint _tmp39__length2;
		gint _tmp40_;
		gint _tmp41_;
		Tile* _tmp42_;
		GList* _tmp43_;
		_tmp39_ = self->priv->tiles;
		_tmp39__length1 = self->priv->tiles_length1;
		_tmp39__length2 = self->priv->tiles_length2;
		_tmp40_ = y;
		_tmp41_ = x;
		_tmp42_ = _tmp39_[((_tmp40_ - 1) * _tmp39__length2) + _tmp41_];
		_tmp43_ = _game_connected_tiles (self, _tmp42_);
		cl = g_list_concat (cl, _tmp43_);
	}
	_tmp46_ = x;
	_tmp47_ = self->priv->_columns;
	if ((_tmp46_ + 1) < _tmp47_) {
		Tile** _tmp48_;
		gint _tmp48__length1;
		gint _tmp48__length2;
		gint _tmp49_;
		gint _tmp50_;
		Tile* _tmp51_;
		_tmp48_ = self->priv->tiles;
		_tmp48__length1 = self->priv->tiles_length1;
		_tmp48__length2 = self->priv->tiles_length2;
		_tmp49_ = y;
		_tmp50_ = x;
		_tmp51_ = _tmp48_[(_tmp49_ * _tmp48__length2) + (_tmp50_ + 1)];
		_tmp45_ = _tmp51_ != NULL;
	} else {
		_tmp45_ = FALSE;
	}
	if (_tmp45_) {
		gint _tmp52_;
		Tile** _tmp53_;
		gint _tmp53__length1;
		gint _tmp53__length2;
		gint _tmp54_;
		gint _tmp55_;
		Tile* _tmp56_;
		gint _tmp57_;
		_tmp52_ = li->color;
		_tmp53_ = self->priv->tiles;
		_tmp53__length1 = self->priv->tiles_length1;
		_tmp53__length2 = self->priv->tiles_length2;
		_tmp54_ = y;
		_tmp55_ = x;
		_tmp56_ = _tmp53_[(_tmp54_ * _tmp53__length2) + (_tmp55_ + 1)];
		_tmp57_ = _tmp56_->color;
		_tmp44_ = _tmp52_ == _tmp57_;
	} else {
		_tmp44_ = FALSE;
	}
	if (_tmp44_) {
		Tile** _tmp58_;
		gint _tmp58__length1;
		gint _tmp58__length2;
		gint _tmp59_;
		gint _tmp60_;
		Tile* _tmp61_;
		GList* _tmp62_;
		_tmp58_ = self->priv->tiles;
		_tmp58__length1 = self->priv->tiles_length1;
		_tmp58__length2 = self->priv->tiles_length2;
		_tmp59_ = y;
		_tmp60_ = x;
		_tmp61_ = _tmp58_[(_tmp59_ * _tmp58__length2) + (_tmp60_ + 1)];
		_tmp62_ = _game_connected_tiles (self, _tmp61_);
		cl = g_list_concat (cl, _tmp62_);
	}
	_tmp65_ = x;
	if ((_tmp65_ - 1) >= 0) {
		Tile** _tmp66_;
		gint _tmp66__length1;
		gint _tmp66__length2;
		gint _tmp67_;
		gint _tmp68_;
		Tile* _tmp69_;
		_tmp66_ = self->priv->tiles;
		_tmp66__length1 = self->priv->tiles_length1;
		_tmp66__length2 = self->priv->tiles_length2;
		_tmp67_ = y;
		_tmp68_ = x;
		_tmp69_ = _tmp66_[(_tmp67_ * _tmp66__length2) + (_tmp68_ - 1)];
		_tmp64_ = _tmp69_ != NULL;
	} else {
		_tmp64_ = FALSE;
	}
	if (_tmp64_) {
		gint _tmp70_;
		Tile** _tmp71_;
		gint _tmp71__length1;
		gint _tmp71__length2;
		gint _tmp72_;
		gint _tmp73_;
		Tile* _tmp74_;
		gint _tmp75_;
		_tmp70_ = li->color;
		_tmp71_ = self->priv->tiles;
		_tmp71__length1 = self->priv->tiles_length1;
		_tmp71__length2 = self->priv->tiles_length2;
		_tmp72_ = y;
		_tmp73_ = x;
		_tmp74_ = _tmp71_[(_tmp72_ * _tmp71__length2) + (_tmp73_ - 1)];
		_tmp75_ = _tmp74_->color;
		_tmp63_ = _tmp70_ == _tmp75_;
	} else {
		_tmp63_ = FALSE;
	}
	if (_tmp63_) {
		Tile** _tmp76_;
		gint _tmp76__length1;
		gint _tmp76__length2;
		gint _tmp77_;
		gint _tmp78_;
		Tile* _tmp79_;
		GList* _tmp80_;
		_tmp76_ = self->priv->tiles;
		_tmp76__length1 = self->priv->tiles_length1;
		_tmp76__length2 = self->priv->tiles_length2;
		_tmp77_ = y;
		_tmp78_ = x;
		_tmp79_ = _tmp76_[(_tmp77_ * _tmp76__length2) + (_tmp78_ - 1)];
		_tmp80_ = _game_connected_tiles (self, _tmp79_);
		cl = g_list_concat (cl, _tmp80_);
	}
	result = cl;
	return result;
}


GList*
game_connected_tiles (Game* self,
                      Tile* li)
{
	GList* result = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GList* cl = NULL;
	GList* _tmp4_;
	GList* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (li != NULL, NULL);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				Tile* _tmp2_;
				_tmp2_ = l;
				if (_tmp2_ != NULL) {
					Tile* _tmp3_;
					_tmp3_ = l;
					_tmp3_->visited = FALSE;
				}
				_g_object_unref0 (l);
			}
		}
	}
	_tmp4_ = _game_connected_tiles (self, li);
	cl = _tmp4_;
	_tmp5_ = cl;
	if (g_list_length (_tmp5_) < ((guint) 2)) {
		__g_list_free__g_object_unref0_0 (cl);
		cl = NULL;
	}
	result = cl;
	return result;
}


Tile*
game_get_tile (Game* self,
               gint x,
               gint y)
{
	Tile* result = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	_tmp1_ = _tmp0_[(y * _tmp0__length2) + x];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}


gboolean
game_remove_connected_tiles (Game* self,
                             Tile* tile)
{
	gboolean result = FALSE;
	GList* cl = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gint new_x = 0;
	GList* _tmp69_;
	gboolean _tmp70_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (tile != NULL, FALSE);
	_tmp0_ = game_connected_tiles (self, tile);
	cl = _tmp0_;
	_tmp1_ = cl;
	if (_tmp1_ == NULL) {
		result = FALSE;
		__g_list_free__g_object_unref0_0 (cl);
		return result;
	}
	_tmp2_ = cl;
	{
		GList* l_collection = NULL;
		GList* l_it = NULL;
		l_collection = _tmp2_;
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
			Tile* _tmp3_;
			Tile* l = NULL;
			_tmp3_ = _g_object_ref0 ((Tile*) l_it->data);
			l = _tmp3_;
			{
				Tile* _tmp4_;
				_tmp4_ = l;
				tile_set_closed (_tmp4_, TRUE);
				_g_object_unref0 (l);
			}
		}
	}
	new_x = 0;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				gint _tmp8_;
				GList* not_closed_tiles = NULL;
				GList* closed_tiles = NULL;
				GList* _tmp26_;
				gboolean has_empty_col = FALSE;
				gboolean _tmp55_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = x;
					x = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = x;
				_tmp8_ = self->priv->_columns;
				if (!(_tmp7_ < _tmp8_)) {
					break;
				}
				not_closed_tiles = NULL;
				closed_tiles = NULL;
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							gint _tmp11_;
							gint _tmp12_;
							Tile* li = NULL;
							Tile** _tmp13_;
							gint _tmp13__length1;
							gint _tmp13__length2;
							gint _tmp14_;
							gint _tmp15_;
							Tile* _tmp16_;
							Tile* _tmp17_;
							Tile* _tmp18_;
							Tile* _tmp19_;
							gboolean _tmp20_;
							gboolean _tmp21_;
							if (!_tmp9_) {
								gint _tmp10_;
								_tmp10_ = y;
								y = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							_tmp11_ = y;
							_tmp12_ = self->priv->_rows;
							if (!(_tmp11_ < _tmp12_)) {
								break;
							}
							_tmp13_ = self->priv->tiles;
							_tmp13__length1 = self->priv->tiles_length1;
							_tmp13__length2 = self->priv->tiles_length2;
							_tmp14_ = y;
							_tmp15_ = x;
							_tmp16_ = _tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_];
							_tmp17_ = _g_object_ref0 (_tmp16_);
							li = _tmp17_;
							_tmp18_ = li;
							if (_tmp18_ == NULL) {
								_g_object_unref0 (li);
								break;
							}
							_tmp19_ = li;
							_tmp20_ = tile_get_closed (_tmp19_);
							_tmp21_ = _tmp20_;
							if (_tmp21_) {
								Tile* _tmp22_;
								Tile* _tmp23_;
								_tmp22_ = li;
								_tmp23_ = _g_object_ref0 (_tmp22_);
								closed_tiles = g_list_append (closed_tiles, _tmp23_);
							} else {
								Tile* _tmp24_;
								Tile* _tmp25_;
								_tmp24_ = li;
								_tmp25_ = _g_object_ref0 (_tmp24_);
								not_closed_tiles = g_list_append (not_closed_tiles, _tmp25_);
							}
							_g_object_unref0 (li);
						}
					}
				}
				_tmp26_ = closed_tiles;
				closed_tiles = NULL;
				not_closed_tiles = g_list_concat (not_closed_tiles, _tmp26_);
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp27_ = FALSE;
						_tmp27_ = TRUE;
						while (TRUE) {
							gint _tmp29_;
							gint _tmp30_;
							Tile** _tmp31_;
							gint _tmp31__length1;
							gint _tmp31__length2;
							gint _tmp32_;
							gint _tmp33_;
							GList* _tmp34_;
							gint _tmp35_;
							gconstpointer _tmp36_;
							Tile* _tmp37_;
							Tile* _tmp38_;
							if (!_tmp27_) {
								gint _tmp28_;
								_tmp28_ = y;
								y = _tmp28_ + 1;
							}
							_tmp27_ = FALSE;
							_tmp29_ = y;
							_tmp30_ = self->priv->_rows;
							if (!(_tmp29_ < _tmp30_)) {
								break;
							}
							_tmp31_ = self->priv->tiles;
							_tmp31__length1 = self->priv->tiles_length1;
							_tmp31__length2 = self->priv->tiles_length2;
							_tmp32_ = y;
							_tmp33_ = new_x;
							_tmp34_ = not_closed_tiles;
							_tmp35_ = y;
							_tmp36_ = g_list_nth_data (_tmp34_, (guint) _tmp35_);
							_tmp37_ = _g_object_ref0 ((Tile*) _tmp36_);
							_g_object_unref0 (_tmp31_[(_tmp32_ * _tmp31__length2) + _tmp33_]);
							_tmp31_[(_tmp32_ * _tmp31__length2) + _tmp33_] = _tmp37_;
							_tmp38_ = _tmp31_[(_tmp32_ * _tmp31__length2) + _tmp33_];
						}
					}
				}
				has_empty_col = TRUE;
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp39_ = FALSE;
						_tmp39_ = TRUE;
						while (TRUE) {
							gint _tmp41_;
							gint _tmp42_;
							Tile* l = NULL;
							Tile** _tmp43_;
							gint _tmp43__length1;
							gint _tmp43__length2;
							gint _tmp44_;
							gint _tmp45_;
							Tile* _tmp46_;
							Tile* _tmp47_;
							Tile* _tmp48_;
							Tile* _tmp49_;
							gint _tmp50_;
							gint _tmp51_;
							Tile* _tmp52_;
							gboolean _tmp53_;
							gboolean _tmp54_;
							if (!_tmp39_) {
								gint _tmp40_;
								_tmp40_ = y;
								y = _tmp40_ + 1;
							}
							_tmp39_ = FALSE;
							_tmp41_ = y;
							_tmp42_ = self->priv->_rows;
							if (!(_tmp41_ < _tmp42_)) {
								break;
							}
							_tmp43_ = self->priv->tiles;
							_tmp43__length1 = self->priv->tiles_length1;
							_tmp43__length2 = self->priv->tiles_length2;
							_tmp44_ = y;
							_tmp45_ = new_x;
							_tmp46_ = _tmp43_[(_tmp44_ * _tmp43__length2) + _tmp45_];
							_tmp47_ = _g_object_ref0 (_tmp46_);
							l = _tmp47_;
							_tmp48_ = l;
							if (_tmp48_ == NULL) {
								_g_object_unref0 (l);
								break;
							}
							_tmp49_ = l;
							_tmp50_ = new_x;
							_tmp51_ = y;
							tile_update_position (_tmp49_, _tmp50_, _tmp51_);
							_tmp52_ = l;
							_tmp53_ = tile_get_closed (_tmp52_);
							_tmp54_ = _tmp53_;
							if (!_tmp54_) {
								has_empty_col = FALSE;
							}
							_g_object_unref0 (l);
						}
					}
				}
				_tmp55_ = has_empty_col;
				if (!_tmp55_) {
					gint _tmp56_;
					_tmp56_ = new_x;
					new_x = _tmp56_ + 1;
				}
				__g_list_free__g_object_unref0_0 (closed_tiles);
				__g_list_free__g_object_unref0_0 (not_closed_tiles);
			}
		}
	}
	{
		gboolean _tmp57_ = FALSE;
		_tmp57_ = TRUE;
		while (TRUE) {
			gint _tmp59_;
			gint _tmp60_;
			if (!_tmp57_) {
				gint _tmp58_;
				_tmp58_ = new_x;
				new_x = _tmp58_ + 1;
			}
			_tmp57_ = FALSE;
			_tmp59_ = new_x;
			_tmp60_ = self->priv->_columns;
			if (!(_tmp59_ < _tmp60_)) {
				break;
			}
			{
				gint y = 0;
				y = 0;
				{
					gboolean _tmp61_ = FALSE;
					_tmp61_ = TRUE;
					while (TRUE) {
						gint _tmp63_;
						gint _tmp64_;
						Tile** _tmp65_;
						gint _tmp65__length1;
						gint _tmp65__length2;
						gint _tmp66_;
						gint _tmp67_;
						Tile* _tmp68_;
						if (!_tmp61_) {
							gint _tmp62_;
							_tmp62_ = y;
							y = _tmp62_ + 1;
						}
						_tmp61_ = FALSE;
						_tmp63_ = y;
						_tmp64_ = self->priv->_rows;
						if (!(_tmp63_ < _tmp64_)) {
							break;
						}
						_tmp65_ = self->priv->tiles;
						_tmp65__length1 = self->priv->tiles_length1;
						_tmp65__length2 = self->priv->tiles_length2;
						_tmp66_ = y;
						_tmp67_ = new_x;
						_g_object_unref0 (_tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_]);
						_tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_] = NULL;
						_tmp68_ = _tmp65_[(_tmp66_ * _tmp65__length2) + _tmp67_];
					}
				}
			}
		}
	}
	_tmp69_ = cl;
	game_increment_score_from_tiles (self, (gint) g_list_length (_tmp69_));
	_tmp70_ = self->priv->is_started;
	if (!_tmp70_) {
		self->priv->is_started = TRUE;
		g_signal_emit (self, game_signals[GAME_STARTED_SIGNAL], 0);
	}
	if (game_has_completed (self)) {
		if (game_has_won (self)) {
			game_increment_score (self, 1000);
		}
		g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
	}
	result = FALSE;
	__g_list_free__g_object_unref0_0 (cl);
	return result;
}


void
game_reset_visit (Game* self)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				Tile* _tmp2_;
				_tmp2_ = l;
				if (_tmp2_ != NULL) {
					Tile* _tmp3_;
					_tmp3_ = l;
					_tmp3_->visited = FALSE;
				}
				_g_object_unref0 (l);
			}
		}
	}
}


gboolean
game_has_completed (Game* self)
{
	gboolean result = FALSE;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				Tile* _tmp4_;
				_tmp4_ = l;
				if (_tmp4_ != NULL) {
					Tile* _tmp5_;
					gboolean _tmp6_;
					gboolean _tmp7_;
					_tmp5_ = l;
					_tmp6_ = tile_get_closed (_tmp5_);
					_tmp7_ = _tmp6_;
					_tmp3_ = !_tmp7_;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					Tile* _tmp8_;
					GList* _tmp9_;
					GList* _tmp10_;
					_tmp8_ = l;
					_tmp9_ = game_connected_tiles (self, _tmp8_);
					_tmp10_ = _tmp9_;
					_tmp2_ = g_list_length (_tmp10_) > ((guint) 1);
					__g_list_free__g_object_unref0_0 (_tmp10_);
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					result = FALSE;
					_g_object_unref0 (l);
					return result;
				}
				_g_object_unref0 (l);
			}
		}
	}
	result = TRUE;
	return result;
}


gboolean
game_has_won (Game* self)
{
	gboolean result = FALSE;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				gboolean _tmp2_ = FALSE;
				Tile* _tmp3_;
				_tmp3_ = l;
				if (_tmp3_ != NULL) {
					Tile* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
					_tmp4_ = l;
					_tmp5_ = tile_get_closed (_tmp4_);
					_tmp6_ = _tmp5_;
					_tmp2_ = !_tmp6_;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					result = FALSE;
					_g_object_unref0 (l);
					return result;
				}
				_g_object_unref0 (l);
			}
		}
	}
	result = TRUE;
	return result;
}


void
game_increment_score_from_tiles (Game* self,
                                 gint n_tiles)
{
	gint points_awarded = 0;
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	points_awarded = 0;
	if (n_tiles >= 3) {
		points_awarded = (n_tiles - 2) * (n_tiles - 2);
	}
	_tmp0_ = points_awarded;
	game_increment_score (self, _tmp0_);
}


void
game_increment_score (Game* self,
                      gint increment)
{
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_score;
	game_set_score (self, _tmp0_ + increment);
	g_signal_emit (self, game_signals[GAME_UPDATE_SCORE_SIGNAL], 0, increment);
}


gint
game_get_score (Game* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_score;
	result = _tmp0_;
	return result;
}


void
game_set_score (Game* self,
                gint value)
{
	g_return_if_fail (self != NULL);
	if (game_get_score (self) != value) {
		self->priv->_score = value;
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_SCORE_PROPERTY]);
	}
}


gint
game_get_color_num (Game* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_color_num;
	result = _tmp0_;
	return result;
}


void
game_set_color_num (Game* self,
                    gint value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value < 2) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = value > 4;
	}
	if (_tmp0_) {
		self->priv->_color_num = 3;
	} else {
		self->priv->_color_num = value;
	}
	g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLOR_NUM_PROPERTY]);
}


gint
game_get_rows (Game* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_rows;
	result = _tmp0_;
	return result;
}


void
game_set_rows (Game* self,
               gint value)
{
	g_return_if_fail (self != NULL);
	if (game_get_rows (self) != value) {
		self->priv->_rows = value;
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_ROWS_PROPERTY]);
	}
}


gint
game_get_columns (Game* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_columns;
	result = _tmp0_;
	return result;
}


void
game_set_columns (Game* self,
                  gint value)
{
	g_return_if_fail (self != NULL);
	if (game_get_columns (self) != value) {
		self->priv->_columns = value;
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLUMNS_PROPERTY]);
	}
}


static void
game_class_init (GameClass * klass)
{
	game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GamePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE_PROPERTY, game_properties[GAME_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLOR_NUM_PROPERTY, game_properties[GAME_COLOR_NUM_PROPERTY] = g_param_spec_int ("color-num", "color-num", "color-num", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ROWS_PROPERTY, game_properties[GAME_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLUMNS_PROPERTY, game_properties[GAME_COLUMNS_PROPERTY] = g_param_spec_int ("columns", "columns", "columns", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	game_signals[GAME_UPDATE_SCORE_SIGNAL] = g_signal_new ("update-score", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	game_signals[GAME_COMPLETE_SIGNAL] = g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	game_signals[GAME_STARTED_SIGNAL] = g_signal_new ("started", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
game_instance_init (Game * self)
{
	self->priv = GAME_GET_PRIVATE (self);
	self->priv->is_started = FALSE;
	self->priv->_score = 0;
	self->priv->_color_num = 3;
	self->priv->_rows = 8;
	self->priv->_columns = 8;
}


static void
game_finalize (GObject * obj)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
}


/**
 *  This is the model layer of the whole game. All game logic goes here. This class tries not to
 *  bring in any visual stuff to comply the separation of view-model idea.
 */
GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}


static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_SCORE_PROPERTY:
		g_value_set_int (value, game_get_score (self));
		break;
		case GAME_COLOR_NUM_PROPERTY:
		g_value_set_int (value, game_get_color_num (self));
		break;
		case GAME_ROWS_PROPERTY:
		g_value_set_int (value, game_get_rows (self));
		break;
		case GAME_COLUMNS_PROPERTY:
		g_value_set_int (value, game_get_columns (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_SCORE_PROPERTY:
		game_set_score (self, g_value_get_int (value));
		break;
		case GAME_COLOR_NUM_PROPERTY:
		game_set_color_num (self, g_value_get_int (value));
		break;
		case GAME_ROWS_PROPERTY:
		game_set_rows (self, g_value_get_int (value));
		break;
		case GAME_COLUMNS_PROPERTY:
		game_set_columns (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



